
// AVL
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <graphics.h>
#include <iomanip.h>
#include <iostream.h>
#define falso 0
#define verdadero 1


  typedef struct _AVL
   { int dato, balance ;
     struct _AVL *izq, *der;
   } AVL ;
 int vacia(AVL *p)
 {  return p == NULL ;
 }
  char s[5];

  void GmuestraAVL(AVL *p, int nivel, int col, int pos, int i)
 {

    if ( !vacia(p) )
      {
	GmuestraAVL(p->izq,nivel+1,col-pos/2,pos/2,col);
	itoa(p->dato,s,10);
	setcolor(11);
	line(i,(nivel-1)*45,col,nivel*45) ;
	circle(col,nivel*45,10);
	setcolor(14);
	outtextxy(col-5,nivel*45-5,s);
	GmuestraAVL(p->der,nivel+1,col + pos/2, pos/2,col);
      }
 }

 AVL  *insertaAVL( AVL *p, int d, int *bandera)
 {
    AVL *q, *p1, *p2 ;
    if (vacia(p))
       {  	 // llego a una hoja
	 q = new AVL ;
	 if ( q == NULL )
	   {
	    cout << " se acabo la memoria ..." << endl;
	    return NULL ;
	   }
	 q->dato = d ; q->balance = 0 ; q->izq = q->der = NULL ;
	 *bandera = verdadero;
	 return q;
       } // fin de vacio
    else if ( d < p->dato)
      { // inserte a la izquierda
	 p->izq = insertaAVL(p->izq,d, bandera);
	 if ( *bandera )  // es verdadera
	 switch ( p->balance )
	    {
	       case 1 : p->balance = 0 ; *bandera = falso ; break;
	       case 0 : p->balance = -1 ; break ;
	       case -1: // rebalanceo
		       p1 = p->izq;
		       if ( p1->balance == -1 )  // rotacion LL
			  {
			     p->izq = p1->der; p1-> der = p;
			     p->balance = 0 ;  p = p1 ;
			   }
			 else
			   {			// rotacion LR
			       p2 = p1->der ;
			       p1->der = p2->izq; p2->izq = p1;
			       p->izq = p2->der;  p2->der = p ;
			       if (p2->balance == -1) p->balance = 1 ;
			       else p->balance = 0 ;
			       if (p2->balance == 1) p1->balance = -1 ;
			       else  p1->balance = 0 ;
			       p = p2 ;
			    }
			  p->balance = 0 ; *bandera = falso ;
		    }     // fin del switch
      }
    else  if ( p->dato < d )
      {         // inserta a la derecha
	      p->der = insertaAVL(p->der,d,bandera);
	      if ( *bandera )  // es verdadera
	       switch ( p->balance )
		 {
		 case -1 : p->balance = 0 ;
			   *bandera = falso ;
			   break;
		 case 0 : p->balance = 1 ;
			   break ;
		 case 1 : // rebalanceo
			   p1 = p->der;
			   if ( p1->balance == 1 )  // rotacion RR
			   {
				p->der= p1->izq; p1-> izq = p;
				p->balance = 0 ;  p = p1 ;
			   }
			   else
			   {			// rotacion RL
				p2 = p1->izq;
				p1->izq = p2->der; p2->der = p1;
				p->der = p2->izq;  p2->izq = p ;
				if (p2->balance == 1)
				  p->balance = -1 ;
				else
				  p->balance = 0 ;
				if (p2->balance == -1)
				  p1->balance = 1 ;
				else
				  p1->balance = 0 ;
				p = p2 ;
			   }
			p->balance = 0 ; *bandera = falso ;
		      } // fin del switch
      }
    else
    {  gotoxy(1,1);
       printf("No se aceptan datos repetidos");
       getch();
     }
    return p;
 }

 AVL  *eliminaAVL( AVL *p , int i)
 {
  // debes hacer el algoritmo
 }

  ////////////////////////////////////   principal
 void main ( void )
 {
    AVL *Q = NULL ;
    int i,j,k;
     int gdriver = DETECT, gmode, errorcode;

    k = 0 ;
    randomize();
    initgraph(&gdriver, &gmode, "c:\\tc\\bin\\lib");
   setbkcolor(1);
   for (  i = 0 ; i <64 ; i++)
     {   j = random(200);
       Q = insertaAVL(Q,j,&k  ); // se inserta al azar ...
       cleardevice(); k = 0 ;
       GmuestraAVL(Q,1,310,310,310);

       getch();
   }
   cleardevice();
   closegraph();
  }
