#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <graphics.h>
#include <iomanip.h>
#include <iostream.h>

  typedef struct _ABB
   { int dato ;
     struct _ABB *izq, *der;
   } ABB ;
 int vacia(ABB *p)
 {  return p == NULL ;
 }
  char s[5];

  void GmuestraABB(ABB *p, int nivel, int col, int pos, int i)
 {

    if ( !vacia(p) )
      {
	GmuestraABB(p->izq,nivel+1,col-pos/2,pos/2,col);
	itoa(p->dato,s,10);
	setcolor(11);
	line(i,(nivel-1)*45,col,nivel*45) ;
	circle(col,nivel*45,10);
	setcolor(14);
	outtextxy(col-5,nivel*45-5,s);
	GmuestraABB(p->der,nivel+1,col + pos/2, pos/2,col);
      }
 }

 ABB  *insertaABB( ABB *p, int d)
 {      // en una lista doble los datos estan ordenados ...
    ABB *q ;

    if (vacia(p))
       {  	 // llego a una hoja
	 q = new ABB ;
	 if ( q == NULL )
	   {
	    cout << " se acabo la memoria ..." << endl;
	    return NULL ;
	   }
	 q->dato = d ;    cout << d << endl;
	 q->izq = q->der = NULL ;
	 return q;
       }
    else if ( d < p->dato)     // inserte a la izquierda
       p->izq = insertaABB(p->izq,d);
    else
       p->der = insertaABB(p->der,d);
    return p;
 }
 ABB *HijoMayor(ABB *t)
 {
     while ( t->der != NULL ) t = t->der;
     return t;
 }
 ABB  *eliminaABB( ABB *p , int i)
 {
    ABB *q;
    if ( !vacia(p))
       if ( p->dato == i)  // el dato a eliminar esta en la raiz.
	 if ((p->izq == NULL ) && ( p->der == NULL))
	   {
	      delete p;
	      return NULL;
	   }
	 else
	   {  q = NULL ;
	      if (p->izq != NULL )
		  q = HijoMayor(p->izq);
	      else      // no existe rama izquierda
		{
		  q = p ;
		  p = p->der;
		  delete q;
		  return p;
		}
	      p->dato = q->dato;   // reemplaza a la raiz
	      i = q->dato;
	      p->izq = eliminaABB(p->izq,i);//elimino la hoja que tiene i
	    }
       else // no esta en la raiz debo buscarlo
	 if ( i < p->dato )
	      p->izq = eliminaABB(p->izq,i);
	 else
	      p->der = eliminaABB(p->der,i);
    return p;
 }

void Explicacion(void)
{
   setcolor(3);
  outtextxy(70,460,"Se insertaron 41 datos al azar en un ABB, luego se pide eliminar");
   outtextxy(70,470,"20 nmeros, para ver como funciona el algoritmo");

}


  ////////////////////////////////////   principal
 void main ( void )
 {
    ABB *Q = NULL ;
    int i;
    int gdriver = DETECT, gmode, errorcode;
    randomize();

   for (  i = 0 ; i <41 ; i++)
      Q = insertaABB(Q,random (100)  ); // se inserta al azar ...

   initgraph(&gdriver, &gmode, "c:\\tc\\bgi");
   setbkcolor(1);
   cleardevice();
   GmuestraABB(Q,1,310,310,310);
   Explicacion();
   getch();

  int fuera ;


  for ( i = 0 ; i < 20 ; i++)
    {
       outtextxy(10,10,"\ cual se elimina? -->");
       gotoxy(25,1);scanf("%d",&fuera);
       cleardevice();
       Q = eliminaABB(Q,fuera);
       GmuestraABB(Q,1,310,310,310) ;
       Explicacion();
     }
   cleardevice();
   closegraph();
  }
