#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <graphics.h>
		       // este programa es un ejemplo de un arbol heap
typedef struct _Pila
   { int dato ;
     struct _Pila *sig;
   } Pila ;

 Pila  *ponePila( Pila *p, int d)
 {
    Pila *q ;
    q = new Pila ;
    q->dato = d ;
    q->sig = p ;
    return q;
 }
 Pila *sacaPila( Pila *p , int *i)
 {
    Pila *q;
    *i = p->dato;
    q = p ;
    p = p->sig;
    delete   q;
    return p;
 }
 int vacia(Pila *p)
 {  return p == NULL ;
 }


  typedef struct _HEAP
   { int dato ;
     struct _HEAP *izq, *der;
   } HEAP ;

 int vacia(HEAP *p)
 {  return p == NULL ;
 }
  char s[5];

  void GmuestraHEAP(HEAP *p, int nivel, int col, int pos, int i)
 {

    if ( !vacia(p) )
      {
	GmuestraHEAP(p->izq,nivel+1,col-pos/2,pos/2,col);
	itoa(p->dato,s,10);
	setcolor(6);
	line(i,(nivel-1)*45,col,nivel*45) ;
	circle(col,nivel*45,10);
	setcolor(1);
	outtextxy(col-5,nivel*45-5,s);
	GmuestraHEAP(p->der,nivel+1,col + pos/2, pos/2,col);
      }
 }

 HEAP  *inserta( HEAP *h, Pila *s, int d)
 {

    if (vacia(h))
       {
	 h= new HEAP ;
	 h->dato = d ;
	 h->izq = h->der = NULL ;
	 return h;
       }
    else
       {
	 int j;
	 if ( d > h->dato)
	  {
	     j = d ;
	     d = h->dato;
	     h->dato = j;
	  }
	 s = sacaPila(s,&j);
	 if ( j % 2 == 0 )
	   h->izq = inserta(h->izq,s,d);
	 else
	   h->der = inserta(h->der,s,d);
	}
    return h;
 }
 HEAP *insertaHEAP(HEAP *h, int j , int d ) // el heap tiene j-1 datos
 {                         // ahora se pondra el dato d en la posicion j
     Pila*  stack = NULL;
     while ( j > 1)
       {
	  stack = ponePila(stack,j);
	  j = j / 2 ;
       }
     h = inserta( h , stack , d );
     return h;
 }

 HEAP  *eliminaHEAP( HEAP *raiz , int *i, int numDatos)
 {
    HEAP *q, *p;  int j=0; int k = numDatos; Pila*  stack = NULL;
    if ( !vacia(raiz))
    {
      *i = raiz->dato ;  // salvo el dato de la raiz
      j = 1; // en j se guarda el camino al elemento a eliminar
      if ( raiz->izq == NULL )   // en este caso solo existe una dato en el arbol
	{
	   delete raiz; raiz = NULL ;
	}
      else if ( raiz->der == NULL ) // solo existe hijo izquierdo
	{
	  raiz->dato = raiz->izq->dato ; delete raiz->izq ; raiz->izq = NULL;
	}
      else // la raiz  tiene dos hijos, elijo al mayor de ellos
	{   p = q = raiz ;
	    do
	      {  q = p ; j *= 2 ;
		 if ( p->izq->dato > p->der->dato )
		  {
		    p->dato = p->izq->dato  ; p = p->izq;
		  }
		else
		  {
		    p->dato = p->der->dato ; p = p->der; j++;
		  }
	      } while (p->der != NULL);
	      if  (( p->izq == NULL ) && (p->der == NULL ))
	      {                          // llego a una hoja
		 if ( q->izq == p) // aca se sabe a que lado
		   q->izq = NULL ;          // de esta q
		 else
		   q->der = NULL ;
		 delete p;    // borra al hijo p y deja al padre q
	      }
	     else
		{ p->dato = p->izq->dato  ; q = p;
		  p = p->izq; j *= 2 ;q->izq = NULL; delete p;
		}
	  if ( j != numDatos )  // debo llegar al enesimo dato
	    {			// para reemplazar al de la posicion j
	       while ( k > 1)
		{
		   stack = ponePila(stack,k);
		   k /= 2 ;
		}
	       q = raiz ;
	       while (!vacia(stack))
		{
		   stack = sacaPila(stack, &k);
		   p = q ;
		   if ( k % 2 == 0 )
		     q = q->izq;
		   else
		     q = q->der;
		}
		 k = q->dato;
		 if ( p->izq == q) // con esto se sabe a que lado
		     p->izq = NULL ;       // de p est q
		 else
		   p->der = NULL ;
		 delete q;
	       raiz = insertaHEAP ( raiz , j , k );
	    }
	}
    }
    return raiz;
 }

  ////////////////////////////////////   principal
 void main ( void )
 {
   HEAP *Q = NULL ;
   int i, datosEnElHeap=0;
   int gdriver = DETECT, gmode;
   randomize();
   for (  i = 0 ; i < 25 ; i++)
     Q = insertaHEAP(Q,++datosEnElHeap,random (220)); //se inserta al azar ..
   initgraph(&gdriver, &gmode, "");
   setbkcolor(7);
   GmuestraHEAP(Q,1,310,310,310);
   getch();
  int fuera ;
  for ( i = 0 ; i < 26 ; i++)
    {
       Q = eliminaHEAP(Q,&fuera, datosEnElHeap--);
       cleardevice();
    //   gotoxy(1,1);printf("\ se eliminar la raiz -->%d",Q->dato);
	outtextxy(70,360,"se eliminar el dato de la raz");

       GmuestraHEAP(Q,1,310,310,310) ;
       getch();
     }
   cleardevice();
   closegraph();
  }
